////////////////////////////////////////////////////////////////////////////////////////
// copy the "Bouncing ball" folder inside your 3DGS folder
// open level1.wmp, build it and run it using bouncing.wdl
////////////////////////////////////////////////////////////////////////////////////////

var video_mode = 7; // 800x600
var video_depth = 32; // 32 bit mode

var ball_speed[3] = 0, 0, 3; // initial speed on the x, y, z axis
var trace_dist;
var max_height = 70;

//////////////////////////////////////////////////////////////////////////

entity* ball;

//////////////////////////////////////////////////////////////////////////

sound beep_sound = <beep.wav>;

//////////////////////////////////////////////////////////////////////////

string level1_wmb = <level1.wmb>;

/////////////////////////////////////////////////////////////////////////

function reverse_speed();

/////////////////////////////////////////////////////////////////////////

function main()
{
	fps_max = 60;
	level_load (level1_wmb);
	wait (3);
	while (1)
	{
		camera.x = ball.x - 200;
		camera.y = ball.y;
		camera.z = 100;
		camera.tilt = -45;
		wait (1);
	}
}

action bouncing_ball
{
	ball = my;
	my.enable_block = on;
	my.enable_entity = on;
	my.event = reverse_speed;	
	while (1)
	{
		if (key_cuu == on)
		{
			ball_speed.x = 5 * time;
			my.tilt -= 8 * time;
		}
		if (key_cud == on)
		{
			ball_speed.x = -5 * time;
			my.tilt += 8 * time;
		}
		if ((key_cuu == off) && (key_cud == off))
		{
			ball_speed.x = 0;
		}
		if (key_cul == on)
		{
			ball_speed.y = 5 * time;
			my.roll += 8 * time;
		}
		if (key_cur == on)
		{
			ball_speed.y = -5 * time;
			my.roll -= 8 * time;
		}
		if ((key_cuu == off) && (key_cud == off))
		{
			ball_speed.x = 0;
		}
		if ((key_cul == off) && (key_cur == off))
		{
			ball_speed.y = 0;
		}
		vec_set (temp, my.x);
		temp.z -= 10000;
		trace_mode = ignore_me + ignore_passable + use_box; // use a thick trace ray (don't allow the ball to get stuck)
		trace_dist = trace(my.x, temp);
		if (trace_dist > max_height) // the ball has reached its maximum height?
		{
			ball_speed.z = -abs(ball_speed.z); // then give the ball a negative speed
		}
		ent_move (nullvector, ball_speed);
		wait(1);		
	}
}

function reverse_speed()
{
	ball_speed.z *= -1;
}
