//////////////////////////////////////////////////////////////////////////
// the lines below are needed if you want to run level2.wdl
// as a standalone script; comment them if you want to 
// change from level1 to level2 automatically
//////////////////////////////////////////////////////////////////////////

var video_mode = 7; // 800x600
var video_depth = 32; // 32 bit mode
var max_entities = 5000;
var players_shield = 100;
var players_ammo = 300;
var score_value = 0; // will be converted to a string and displayed on the screen

font figures_font = <font.tga>, 15, 15;
font score_font = <scorefont.tga>, 15, 15; // same font with a blueish touch

string level2_wmb = <level2.wmb>;
string level3_wmb = <level3.wmb>;
string score_str = "00000000";
string temp_str; // just a temporary string

bmap shield_tga = <shield.tga>;
bmap ammo_tga = <ammo.tga>;
bmap score_tga = <score.tga>;

function main()
{
	fps_max = 60;
	level_load (level2_wmb);
}

panel shield_pan
{
	bmap = shield_tga;
	layer = 10;
	pos_x = 732;
	pos_y = 555;
	digits = 7, 15, 3, figures_font, 1, players_shield;
	flags = overlay, refresh, visible, transparent;
}

panel ammo_pan
{
	bmap = ammo_tga;
	layer = 10;
	pos_x = 0;
	pos_y = 555;
	digits = 12, 15, 3, figures_font, 1, players_ammo;
	flags = overlay, refresh, visible, transparent;
}

panel score_pan
{
	bmap = score_tga;
	layer = 10;	
	pos_x = 300;
	pos_y = 5;
	flags = overlay, refresh, visible;
}

text score_txt 
{ 
	pos_x = 380; 
	pos_y = 5; 
	layer = 10;
	font = score_font; 
	string = score_str;
	flags = visible;
} 

starter compute_score()
{
	while (1)
	{
		str_for_num(temp_str, score_value); // convert the value to string
		if (str_len(temp_str) == 1)
		{
			str_cpy(score_str, "0000000");
			str_cat(score_str, temp_str);
		}
		if (str_len(temp_str) == 2)
		{
			str_cpy(score_str, "000000");
			str_cat(score_str, temp_str);
		}
		if (str_len(temp_str) == 3)
		{
			str_cpy(score_str, "00000");
			str_cat(score_str, temp_str);
		}
		if (str_len(temp_str) == 4)
		{
			str_cpy(score_str, "0000");
			str_cat(score_str, temp_str);
		}
		if (str_len(temp_str) == 5)
		{
			str_cpy(score_str, "000");
			str_cat(score_str, temp_str);
		}
		if (str_len(temp_str) == 6)
		{
			str_cpy(score_str, "00");
			str_cat(score_str, temp_str);
		}
		if (str_len(temp_str) == 7)
		{
			str_cpy(score_str, "0");
			str_cat(score_str, temp_str);
		}
		if (str_len(temp_str) == 8)
		{
			str_cat(score_str, temp_str);
		}
		wait (1);
	}
}

// the lines that are needed to run this script as a standalone project end here

/////////////////////////////////////////////////////////////////////////////////////////////

var starfield_speed = 2; // controls the global speed of the starfield
var ship_down = 0;
var level_number = 0;

/////////////////////////////////////////////////////////////////////////////////////////////

define follow_player flag1;

/////////////////////////////////////////////////////////////////////////////////////////////

include <explosions.wdl>;

/////////////////////////////////////////////////////////////////////////////////////////////

function particle_init();
function size_particles();
function destroy_them();
function move_bullet1();
function move_bullet2();
function move_bullet3();
function player_fires();
function particles_explo1();
function particles_explo2();
function particles_explo3();
function explode_1();
function explode_2();
function explode_3();
function destroy_bullet();
function damage_player();
function move_sphere();
function particle_effect3();
function destroy_particles();
function move_player();
function players_bullet();
function move_players_bullet();
function remove_bullet();

/////////////////////////////////////////////////////////////////////////////////////////////

bmap star_tga = <star.tga>;
bmap explo_tga = <explo.tga>;
bmap explo2_tga = <explo2.tga>;
bmap glow_tga = <glow.tga>;

/////////////////////////////////////////////////////////////////////////////////////////////

string laser_mdl = <laser.mdl>;
string laser2_mdl = <laser2.mdl>;
string laserboss_mdl = <laserboss.mdl>;
string sphere_mdl = <sphere.mdl>;
string bolt_mdl = <bolt.mdl>;	
string myhero_mdl = <human.mdl>;
string pbullet_mdl = <pbullet.mdl>;

//////////////////////////////////////////////////////////////////////////

sound fire1_wav = <fire1.wav>;
sound fire2_wav = <fire2.wav>;
sound explo1_wav = <explo1.wav>;
sound playerhit_wav = <playerhit.wav>;
sound bossexplo_wav = <bossexplo.wav>;
sound scanning_wav = <scanning.wav>;
sound smoked_wav = <smoked.wav>;
sound wind3_wav = <wind3.wav>;
sound jump_wav = <jump.wav>;
sound bullet_wav = <bullet.wav>;
sound phit_wav = <phit.wav>;

//////////////////////////////////////////////////////////////////////////

entity* first_boss;
entity* player_1st; // player in first person mode

//////////////////////////////////////////////////////////////////////////

starter particle_generator
{
	var particle_start[3];
	while (player == null) {wait (1);}
	camera.pan = 0; // now set the new camera position and angles
	camera.tilt = -90;
	camera.roll = 0;
	camera.x = 330;
	camera.y = 0;
	camera.z = 1000;
	while(player.z > -8000) 
	{
		particle_start.x = 1000;
		particle_start.y = 1000 - random(2000);
		particle_start.z = -500 + random(200);
		effect (particle_init, 1, particle_start, normal); 
		wait (1);
	}
}

function particle_init() 
{ 
	temp.x = -(2 + random (15)) * starfield_speed; 
	temp.y = 0; 
	temp.z = 0;
	vec_add (my.vel_x, temp); 
	my.bmap = star_tga; 
	my.alpha = 40 + random(60); // play with this value 
	my.size = 5 + random(5);
	my.bright = on; 
	my.move = on; 
	my.lifespan = 500;
	my.function = size_particles;
} 

function size_particles()
{
	my.size += 0.01 * time;
}

action player_level2
{
	player = my;
	my.ambient = -100;
	my.enable_impact = on;
	my.enable_entity = on;
	my.enable_scan = on;
	my.event = damage_player;
	var speed_factor_x;
	var speed_factor_y;
	while (players_shield > 0)
	{
		if (key_cul == on) 
		{
			if (speed_factor_y < 10) {speed_factor_y += 5 * time;}
		}
		else
		{
			if (speed_factor_y > 0) {speed_factor_y -= 2 * time;}
		}	
		if (key_cur == on)
		{
			if (speed_factor_y > -10) {speed_factor_y -= 5 * time;}
		}
		else
		{
			if (speed_factor_y < 0) {speed_factor_y += 2 * time;}
		}			
		if (abs(speed_factor_y) > 1)
		{
			if (((speed_factor_y > 0) && (my.y < 500)) || ((speed_factor_y < 0) && (my.y > -500)))
			{
				my.y += speed_factor_y;
			}
		}
		if (key_cuu == on) 
		{
			if (speed_factor_x < 10) {speed_factor_x += 5 * time;}
		}
		else
		{
			if (speed_factor_x > 0) {speed_factor_x -= 2 * time;}
		}	
		if (key_cud == on)
		{
			if (speed_factor_x > -10) {speed_factor_x -= 5 * time;}
		}
		else
		{
			if (speed_factor_x < 0) {speed_factor_x += 2 * time;}
		}			
		if (abs(speed_factor_x) > 1)
		{
			if (((speed_factor_x > 0) && (my.x < 650)) || ((speed_factor_x < 0) && (my.x > 0)))
			{
				my.x += speed_factor_x;
			}
		}
		if ((key_space == on) || (mouse_left == on))
		{
			player_fires();
		}
		wait (1);
	}
}

function player_fires()
{
	proc_kill(4);
	while ((key_space == on) || (mouse_left == on)) {wait (1);} // wait until the player releases the keys
	snd_play (fire2_wav, 40, 0);
	vec_set (temp.x, my.x);
	temp.x += 70; // the laser is generated in front of the ship
	ent_create (laser2_mdl, temp, move_bullet1);
	players_ammo -= 1;
}

function damage_player()
{
	wait (1);
	if (event_type == event_scan)
	{
		players_shield -= 1 * time;
	}
	if ((event_type == event_impact) || (event_type == event_entity))
	{
		snd_play (playerhit_wav, 70, 0);
		players_shield -= 10;
	}
	my.ambient = 100;
	sleep (0.2);
	my.ambient = -100;
	if (players_shield <= 0)
	{
		players_shield = 0;
		my.invisible = on;
		my.passable = on;
		effect(particles_explo2, 30, my.x,nullvector);
		my.event = null;
	}
}

// uses follow_player
action shuttle
{
	my.ambient = -100;
	while (player == null) {wait (1);}
	my.z = player.z; // set the same height for the enemy ships and the player
	var shuttle_speed;
	my.skill10 = 1;
	my.skill40 = 1; // I'm a ship
	my.enable_impact = on;
	my.event = destroy_them;
	shuttle_speed.x = -2 * time;
	shuttle_speed.y = 0;
	shuttle_speed.z = 0;
	my.skill1 = 1 + int(random(70));
	while ((my.x > -300) && (my.skill10 == 1))
	{
		if (my.follow_player == on)
		{
			vec_set(temp, player.x); // rotate the ship towards player's ship
			vec_sub(temp, my.x); 
			vec_to_angle(my.pan, temp); 
		}
		move_mode = ignore_you + ignore_passable;
		ent_move (nullvector, shuttle_speed);
		if ((vec_dist (my.x, player.x) < 800) && (total_frames % 90 == my.skill1)) // random firing intervals
		{
			if (my.x > player.x) // still got the chance to hit the player?
			{
				snd_play (fire1_wav, 40, 0);
				ent_create (laser_mdl, my.x, move_bullet2);
			}
		}
		wait (1);
	}
	ent_remove (my);
}

function move_bullet1()
{
	var bullet_speed;
	my.passable = on;
	my.skill40 = 99; // player's bullet id
	my.enable_impact = on;
	my.enable_entity = on;
	my.event = destroy_bullet;
	my.pan = you.pan;
	bullet_speed.x = 50 * time;
	bullet_speed.y = 0;
	bullet_speed.z = 0;
	my.ambient = 100;
	my.bright = on;
	my.light = on;
	my.red = 50;
	my.green = 255;
	my.blue = 50;
	while (my.x < 700) // the bullets can destroy only what is visible on the screen
	{
		if (you != null)
		{
			if(vec_dist (my.x, you.x) > 50)
			{
				my.passable = off;
			}			
		} 
		move_mode = ignore_you + ignore_passable;
		ent_move (bullet_speed, nullvector);
		wait (1);
	}
	ent_remove (my);
}

function move_bullet2()
{
	var bullet_speed;
	my.passable = on;
	my.enable_impact = on;
	my.enable_entity = on;
	my.event = destroy_bullet;
	my.pan = you.pan;
	bullet_speed.x = 50 * time;
	bullet_speed.y = 0;
	bullet_speed.z = 0;
	my.ambient = 100;
	my.bright = on;
	my.light = on;
	my.red = 50;
	my.green = 255;
	my.blue = 50;
	while (my != null) // as long as the bullet exists
	{
		if (you != null)
		{
			if(vec_dist (my.x, you.x) > 50)
			{
				my.passable = off;
			}			
		} 
		my.roll += 200 * time;
		move_mode = ignore_you + ignore_passable;
		ent_move (bullet_speed, nullvector);
		wait (1);
	}
}

function destroy_bullet()
{
	wait (1);
	snd_play (explo1_wav, 30, 0);
	ent_remove (my);
}

action asteroid
{
	var asteroid_speed;
	my.metal = on;
	my.ambient = -random(100);
	my.scale_x = 2 + random(5);
	my.scale_y = 2 + random(5);
	my.scale_z = 2 + random(5);
	my.skill40 = 2; // I'm an asteroid
	while (player == null) {wait (1);}
	my.z = player.z; // set the same height for the enemy ships and the player
	my.enable_impact = on;
	my.enable_scan = on;
	my.event = destroy_them;
	asteroid_speed.x = -2 * time;
	asteroid_speed.y = 0;
	asteroid_speed.z = 0;
	my.skill10 = 1;
	my.skill1 = 4 - random(8);
	my.skill2 = 4 - random(8);
	my.skill3 = 4 - random(8);
	while ((my.x > -300) && (my.skill10 == 1))
	{
		move_mode = ignore_you + ignore_passable;
		ent_move (nullvector, asteroid_speed);
		my.pan += my.skill1 * time;
		my.tilt += my.skill2 * time;
		my.roll += my.skill3 * time;
		wait (1);
	}
	ent_remove (my);
}

function particles_explo1()
{ 
	my.bmap = explo_tga;
	my.bright = on;
	my.transparent = on;
	my.alpha = 100;
	my.move = on;
	temp.x = 25 - random(50);
	temp.y = 25 - random(50);
	temp.z = 25 - random(50);
	vec_normalize (temp.x, (3 + random(3)));
	vec_add (my.vel_x, temp.x);
	my.size = 25;
	my.lifespan = 100;
	my.function = explode_1;
}

function explode_1()
{
	my.alpha -= 5 * time;
	my.size += 4 * time;
	if (my.alpha <= 0) 
	{
		my.lifespan = 0;
	}
}

function particles_explo2()
{ 
	my.bmap = explo2_tga;
	my.bright = on;
	my.transparent = on;
	my.alpha = 100;
	my.move = on;
	temp.x = 1 - random(2);
	temp.y = 1 - random(2);
	temp.z = 0;
	vec_normalize (temp.x, (1 + random(1)));
	vec_add (my.vel_x, temp.x);
	my.size = 2;
	my.lifespan = 50;
	my.function = explode_2;
}

function explode_2()
{
	my.alpha -= 4 * time;
	my.size += 3 * time;
	if (my.alpha <= 0) 
	{
		my.lifespan = 0;
	}
}

function particles_explo3()
{ 
	my.bmap = explo2_tga;
	my.bright = on;
	my.transparent = on;
	my.alpha = 100;
	my.move = on;
	temp.x = 1 - random(2);
	temp.y = 1 - random(2);
	temp.z = 0;
	vec_normalize (temp.x, (3 + random(2)));
	vec_add (my.vel_x, temp.x);
	my.size = 4;
	my.lifespan = 50;
	my.function = explode_3;
}

function explode_3()
{
	my.alpha -= 3 * time;
	my.size += 5 * time;
	if (my.alpha <= 0) 
	{
		my.lifespan = 0;
	}
}

action shuttle2
{
	my.ambient = 30;
	while (player == null) {wait (1);}
	my.z = player.z; // set the same height for the enemy ships and the player
	var shuttle_speed;
	my.skill10 = 1;
	my.skill40 = 4; // I'm a ship
	my.enable_impact = on;
	my.event = destroy_them;
	shuttle_speed.x = -2 * time;
	shuttle_speed.y = 0;
	shuttle_speed.z = 0;
	while ((my.x > -300) && (my.skill10 >= 0))
	{
		if ((vec_dist (my.x, player.x) < 800) && (total_frames % 90 == 1))
		{
			if (my.x > player.x) // still got the chance to hit the player?
			{
				snd_play (fire1_wav, 40, 0);
				vec_set (temp.x, my.x);
				temp.x -= 30;
				temp.y -= 83;
				ent_create (bolt_mdl, temp.x, move_bullet2);
				vec_set (temp.x, my.x);
				temp.x -= 30;
				temp.y += 83;
				ent_create (bolt_mdl, temp.x, move_bullet2);
			}
		}
		move_mode = ignore_you + ignore_passable;
		ent_move (nullvector, shuttle_speed);
		wait (1);
	}
	ent_remove (my);
}

action shuttle3
{
	my.ambient = 30;
	while (player == null) {wait (1);}
	ent_create (sphere_mdl, my.x, move_sphere);
	my.z = player.z; // set the same height for the enemy ships and the player
	var shuttle_speed;
	my.skill10 = 1;
	my.skill40 = 1; // I'm a ship
	my.enable_impact = on;
	my.event = destroy_them;
	shuttle_speed.x = -2 * time;
	shuttle_speed.y = 0;
	shuttle_speed.z = 0;
	while ((my.x > -300) && (my.skill10 == 1))
	{
		move_mode = ignore_you + ignore_passable;
		ent_move (nullvector, shuttle_speed);
		wait (1);
	}
	ent_remove (my);
}

function move_sphere()
{
	proc_late();
	var index;
	var vertices;
	my.passable = on;
	my.invisible = on;
	vertices = ent_vertices(my);
	while (you != null)
	{
		vec_set (my.x, you.x);
		if (you.x < 800)
		{
			if (my.scale_x == 1)
			{
				snd_play (scanning_wav, 60, 0); // this sound will be played only once
			}
			my.scale_x += 1 * time;
			my.scale_x = min(30, my.scale_x); // limit the scale to 30
			my.scale_y = my.scale_x;
			my.scale_z = my.scale_x;
			temp.pan = 360; 
			temp.tilt = 360; 
			temp.z = my.scale_x * 37; // 37 = experimental value, must fit the size of the particle sphere
			scan_entity (camera.x, temp);			
		}
		index = 0;
		while (index < vertices) // while without wait!
		{
			vec_for_vertex (temp, my, index);
			effect (particle_effect3, 10, temp, normal); 			
			index += 1;
		}
		my.pan += 3 * time;
		my.tilt += 3 * time;
		my.roll += 3 * time;
		wait (1);
	}
	ent_remove (my);
}

function particle_effect3() 
{ 
	temp.x = 5 - random (10); 
	temp.y = 0; 
	temp.z = 0;
	vec_add (my.vel_x, temp); 
	my.bmap = glow_tga; 
	my.alpha = 80;
	my.size = 5;
	my.bright = on;
	my.move = on;
	my.lifespan = 1;
	my.function = destroy_particles;
} 

function destroy_particles()
{
	my.alpha -= 10 * time;
	if (my.alpha < 0)
	{
		my.lifespan = 0;
	}
}

action boss_level2
{
	first_boss = my;
	my.ambient = -30;
	while (player == null) {wait (1);}
	my.z = player.z; // set the same height for the enemy ships and the player
	var boss_speed;
	my.skill10 = 1;
	my.skill20 = 100;
	my.skill40 = 3; // I'm the boss
	boss_speed.x = -2 * time;
	boss_speed.y = 0;
	boss_speed.z = 0;
	while (my.x > 650)
	{
		move_mode = ignore_you + ignore_passable;
		ent_move (nullvector, boss_speed);
		wait (1);
	}
	my.enable_impact = on;
	my.event = destroy_them;
	boss_speed.x = 0;
	boss_speed.z = 0;
	while (my.skill20 > 0)
	{
		if (player.y > my.y)
		{
			my.y += 5 * time;
		}
		else
		{
			my.y -= 5 * time;
		}
		if (((my.y - player.y) < 200) && (total_frames % 40 == 1))
		{
			if (player.invisible == on) {break;}
			vec_set (temp.x, my.x);
			temp.x -= 120;
			snd_play (fire1_wav, 40, 0);
			ent_create (laserboss_mdl, temp.x, move_bullet3);
			wait (1);
			vec_set (temp.x, my.x);
			temp.x -= 40;
			temp.y += 145;
			snd_play (fire1_wav, 40, 0);
			ent_create (laserboss_mdl, temp.x, move_bullet3);
			wait (1);
			vec_set (temp.x, my.x);
			temp.x -= 40;
			temp.y -= 145;
			snd_play (fire1_wav, 40, 0);
			ent_create (laserboss_mdl, temp.x, move_bullet3);
		}
		wait (1);
	}
	ent_remove (my);
	player.event = null;
}

function move_bullet3() // used by the boss at the end of the level
{
	var bullet_speed;
	my.passable = on;
	my.enable_impact = on;
	my.enable_entity = on;
	my.event = destroy_bullet;
	my.pan = you.pan;
	bullet_speed.x = 35 * time;
	bullet_speed.y = 0;
	bullet_speed.z = 0;
	my.ambient = 100;
	my.bright = on;
	my.light = on;
	my.red = 50;
	my.green = 255;
	my.blue = 50;
	while (my != null) // as long as the bullet exists
	{
		if (you != null)
		{
			if(vec_dist (my.x, you.x) > 50)
			{
				my.passable = off;
			}			
		} 
		if (vec_dist(player.x, my.x) > 400) // not too close to the player?
		{
			vec_set(temp, player.x); // rotate the bullet towards player's ship
			vec_sub(temp, my.x); 
			vec_to_angle(my.pan, temp);
		}
		move_mode = ignore_you + ignore_passable;
		ent_move (bullet_speed, nullvector);
		wait (1);
	}
}

function destroy_them()
{
	snd_play (explo1_wav, 50, 0);
	if (my.skill40 == 1) // a ship was hit?
	{
		my.skill10 = 0;
		if (you.skill40 == 99) // if it was player's bullet
		{
			score_value += 100; // get 100 points for a ship
		}
		effect(particles_explo2, 30, my.x, nullvector);
	}
	if (my.skill40 == 2) // hit one of the asteriods?
	{
		my.skill10 = 0;
		if (you.skill40 == 99) // if it was player's bullet
		{
			score_value += 50; // get 50 points for an asteroid
		}
		effect(particles_explo1, 20, my.x, nullvector);
	}
	if (my.skill40 == 3) // hit the boss at the end of the level?
	{
		my.skill10 = 0;
		if (you.skill40 == 99) // if it was player's bullet
		{
			score_value += 100; // get 100 points for a shot
		}
		my.skill20 -= 10; // decrease the shield for the boss
		if (my.skill20 <= 0)
		{
			snd_play (bossexplo_wav, 100, 0);
			effect(particles_explo3, 100, my.x, nullvector); // similar to the other particle explosions
		}
	}
	if (my.skill40 == 4) // shuttle2 was hit?
	{
		my.skill10 -= 1;
		if (my.skill10 < 0)
		{
			if (you.skill40 == 99) // if it was player's bullet
			{
				score_value += 200; // get 200 points for shuttle2
			}
			effect(particles_explo2, 50, my.x, nullvector);
		}
	}
}

action gate // dummy action, not used yet
{
	my.transparent = off;
}

function ship_explosion(coordinates) // described in detail in the "advanced explosions" article from Aum41
{
	var number_of_gibbits;
	effect (explosion_core, 10 + random(10), coordinates, nullvector);
	sleep (0.3);
	ent_create (explosion_pcx, coordinates, explosion_sprite2);
	sleep (0.1);
	number_of_gibbits = random(15) + 5;
	while (number_of_gibbits > 0) // while without wait!
	{
		ent_create (gibbit_mdl, coordinates, move_gibbits);
		number_of_gibbits -= 1;
	}
}

action metal_asteroid // unbreakable asteroids
{
	var asteroid_speed;
	sleep (3); // wait until first_boss is created
	my.z = player.z; // set the same height for the enemy ships and the player
	my.albedo = 0;
	my.metal = on;
	while (first_boss != null) {wait (1);} // wait until the first boss is destroyed (comment this line to jump to the 3rd level right away)
	sleep (3);
	my.x -= 33000; // come close to the player now because first_boss has disappeared
	my.ambient = -random(100);
	my.scale_x = 2 + random(5); // set a random scale on x, y, z
	my.scale_y = 2 + random(5);
	my.scale_z = 2 + random(5);
	asteroid_speed.x = -15 * time; // the metal asteroids have a big speed
	asteroid_speed.y = 0;
	asteroid_speed.z = 0;
	my.skill1 = 4 - random(8); // set random rotation (pan, tilt, roll) speeds
	my.skill2 = 4 - random(8);
	my.skill3 = 4 - random(8);
	while (my.x > -300)
	{
		move_mode = ignore_you + ignore_passable;
		ent_move (nullvector, asteroid_speed);
		my.pan += my.skill1 * time;
		my.tilt += my.skill2 * time;
		my.roll += my.skill3 * time;
		wait (1);
		if ((vec_dist (player.x, my.x) < 100) && (ship_down == 0)) // the player has come really close to this asteroid?
		{
			ship_down = 1; // bring the ship down (make it land on the terrain from the 3rd level)
			my.invisible = on; // hide the asteroid that has collided with player's ship
			players_shield = 0; // take over the controls from the player
			player.event = null; // the player won't react to hits from now on
			ship_explosion (vector(player.x, player.y, player.z + 20)); // create an explosion
			snd_play (explostart_wav, 100, 0);
			while (player.z > -10000) // move the ship downwards
			{
				player.z -= 100 * time;
				player.roll += 25 * time;
				wait (1);
			}
			level_load (level3_wmb); // load the next level
		}
		if (ship_down == 1) // if the ship was brought down already
		{
			my.passable = on; // don't allow the asteroids to get stuck
		} 
	}
	ent_remove (my); // remove the asteroids as soon as they can't be seen
}

action halo_flare // simple flare effect
{
	my.ambient = 100;
	my.transparent = on;
	my.bright = on;
	my.light = on;
	my.lightred = 255;
	my.lightgreen = 255;
	my.lightblue = 255;
	my.lightrange = 0;
	my.facing = on;
	my.passable = on;
	while(1)
	{
		my.alpha = min(100, vec_dist(my.x, camera.x) / 20); // get the distance to the camera and compute the alpha
		my.scale_x = min(3, my.alpha / 50); // and adjust the scale as needed
		my.scale_y = my.scale_x; // keep the same scale on the y axis
		wait(1);
	}
}

action crystal_glow // light core
{
	my.transparent = on;
	my.bright = on;
	my.ambient = 100;
	my.light = on;
	my.lightred = 255;
	my.lightgreen = 255;
	my.lightblue = 100;
	my.lightrange = 0;
}

starter level3_camera()
{
	camera.clip_far = 100000;
	while (level_number != 3) {wait (1);} // wait until we get to the 3rd level
	while (player == null) {wait (1);} // wait until the player model (the ship) appears in the 3rd level
	camera.x = 20000; // set a convenient position and angles for the camera
	camera.y = 9600;
	camera.z = -500;
	camera.pan = 110;
	camera.tilt = 0;
	camera.roll = 0;	
}

action player_level3 // this is the action attached to the falling ship
{
	player = my;
	my.ambient = -50;
	level_number = 3;
	my.scale_x = 5;
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	my.x = 10000; // set a convenient initial position
	my.y = 28000;
	my.z = 8000;
	my.pan = 295; // and angles
	my.tilt = -50;
	my.skill1 = 15000;
	while (my.skill1 > 100) // fall until the distance to the ground (returned by "trace") is smaller than 100 quants
	{
		vec_set (temp, my.x); 
		temp.z -= 15000; 
		trace_mode = ignore_me + ignore_you + ignore_passable; 
		my.skill1 = trace (my.x, temp); 
		my.roll += 20 * time;
		my.x += 70 * time;
		my.y -= 125 * time;
		my.z -= 120 * time;
		effect (particle_smoke, random(10) + 5, my.x, nullvector); // generate smoke while falling
		wait (1);
	}
	snd_play (explomid_wav, 20, 0); // play the explosion sound
	my.skill1 = 0;
	while (my.skill1 < 100) // shake the camera a bit
	{
		my.skill1 += 10 * time;
		camera.roll = 2 - random(4);
		wait (1);
	}
	sleep (3);
	ent_create (myhero_mdl, my.x, move_player); // create the player model
	while (player_1st == null) {wait (1);} // wait until the player appears
	while (vec_dist (player_1st.x, my.x) < 2000) // continue to create smoke until the player is at least 2,000 quants away
	{
		effect (particle_smoke, random(3) + 2, vector(my.x, my.y + 80, my.z + 200), nullvector);
		wait (1);
	}
}

function move_player() 
{
	var players_speed;
	var track2_playing = 0; // will be set to 1 as soon as the second track (track2.wav) starts to play
	player_1st = my; // I will be the player from now on
	player = null; // remove the default camera code function
	my.invisible = on; // no need to see the model in 1st person mode
	players_shield = 25; // the player is injured
	players_ammo = 30; // and his pistol has 30 bullets (for now)
	my.x = 14830; // choose a convenient position and angles for player's model (smoky!)
	my.y = 19420;
	my.z = -80;
	my.pan = 300;
	my.tilt = -50;
	sleep (1);
	camera.x = my.x;
	camera.y = my.y;
	camera.z = my.z;
	camera.pan = my.pan;
	camera.tilt = my.tilt;
	snd_loop (wind3_wav, 15, 0); // start playing the wind sound in a loop (using snd_play because it loops the sound perfectly)
	snd_play (smoked_wav, 100, 0); // cough cough
	sleep (3);
	while (my.x < 15000) // now jump on the ground
	{
		my.x += 20 * time;
		my.y -= 40 * time;
		my.z -= 25 * time;
		my.tilt += 2 * time;
		camera.x = my.x;
		camera.y = my.y;
		camera.z = my.z;
		camera.tilt = my.tilt;
		wait (1);
	}
	snd_play (jump_wav, 80, 0);	
	while (my.tilt < 0) // look up
	{
		my.tilt += 3 * time;
		camera.tilt = my.tilt;
		wait (1);
	}
	while (players_shield > 0) // as long as the player is alive
	{
		players_speed.x = 15 * (key_w - key_s) * time; // move with w / s
		players_speed.y = 10 * (key_a - key_d) * time; // strafe with a / d
		vec_set (temp, my.x); 
		temp.z -= 5000; 
		trace_mode = ignore_me + ignore_passable + use_box;
		players_speed.z = -trace (my.x, temp); 
		my.pan -= 5 * mouse_force.x; // use the mouse to look around
		my.tilt += 5 * mouse_force.y;
		if (mouse_left == 1) // the player has pressed the left mouse button?
		{
			players_bullet(); // then fire a bullet!
		}
		move_mode = ignore_passable + ignore_passents + glide;
		ent_move(players_speed, nullvector);
		wait (1);
		camera.x = my.x;
		camera.y = my.y;
		camera.z = my.z + 30;
		camera.pan = my.pan;
		camera.tilt = my.tilt;
		if (((my.z < -750) || (mouse_left == 1)) && (track2_playing == 0)) // the player has approached the first base or has pressed the LMB?
		{
			track2_playing = 1;
			media_loop("track2.wav", null, 100); // then start playing the soundtrack
		}
	}
	my.skill46 = 0;
	while (my.skill46 < 80) 
	{
		ent_cycle("death", my.skill46); // play the "death" animation frames
		my.skill46 += 2 * time; 
		wait (1);
	}
}

function players_bullet()
{
	proc_kill(4);
	while (mouse_left == 1) {wait (1);} // disable auto fire
	snd_play (bullet_wav, 50, 0);
	ent_create (pbullet_mdl, player_1st.x, move_players_bullet); // create player's bullet
}

function move_players_bullet()
{
	my.skill47 = 1; // to identify a bullet fired by the player
	my.pan = you.pan; // the bullet and the player have the same pan angle
	my.tilt = you.tilt; // and tilt angle
	my.passable = on; // at first
	my.enable_entity = on; // the bullet is sensitive to other entities
	my.enable_impact = on;
	my.enable_block = on; // and to level blocks
	my.event = remove_bullet;
	my.ambient = 100;
	my.light = on;
	my.lightred = 150;
	my.lightgreen = 150;
	my.lightblue = 255;
	while (my != null)
	{
		if (vec_dist (player_1st.x, my.x) > 30) {my.passable = off;}
		my.skill1 = 100 * time; // bullet speed
		my.skill2 = 0;
		my.skill3 = 0;
		move_mode = ignore_you + ignore_passable;
		ent_move (my.skill1, nullvector);
		my.roll += 100 * time;
		wait (1);
	}
}

function remove_bullet()
{
	my.event = null;
	ent_playsound (my, phit_wav, 1000); // player's bullet hits something
	sleep (0.4);
	ent_remove (me);
}

function toggle_passable()
{
	player.passable = (player.passable == off);	
	if (player.passable == on)
	{
		player.enable_scan = off;
		player.transparent = on;
		player.alpha = 30;	
	}
	else
	{
		player.enable_scan = on;
		player.transparent = off;
		player.alpha = 100;
	}
}

on_t = toggle_passable;
